>           _______           
>          / _____ \          
>         | |     | |         
>         | |     | |         
>         | |     | |   _ __ ___   __ _ _   _  ___         
>         | |     | |  | '__/ _ \ / _` | | | |/ _ \
>         | |_____| |  | | | (_) | (_| | |_| |  __/    
>          \______\_\  |_|  \___/ \__, |\__,_|\___|   
>                                  __/ |            
>                                 |___/ 
ASCII-Art generated by https://www.ascii-art-generator.org/

# Qrogue v0.4 #

Qrogue is a modernized Quantum Computing take of the classical game 
[Rogue](https://en.wikipedia.org/wiki/Rogue_%28video_game%29). 

You will play as a student who's dream is to travel through the galaxy. 
As they hear about "Mission Quniverse" they immediately apply for its 
training program to be able to join this fascinating Quantum Computing 
powered universe exploration mission.


## Table of Contents ##
- Installation
  - Dependencies
  - Linux
  - Windows
- Notes
- How to play - Controls
- Outlook

## Installation ##


### Dependencies ###
- py_cui v0.1.4
- qiskit v0.34.2
- numpy v1.20.1
- antlr4-python3-runtime v4.10

However, these dependencies are installed automatically if you install Qrogue via pip.

### Linux/macOS ###

#### Prerequisites ####

- Python 3.8
- pip

For Linux/macOS you simply have to run 
```bash
pip install qrogue
```
to install Qrogue in your current Python environment. 

Afterwards you can launch the game simply by executing `qrogue` in the Python environment you installed Qrogue in.

### Windows ###

#### Prerequisites ####

Same as for Linux/macOS

## Notes ##

- `py_cui.errors.PyCUIOutOfBoundsError` 

Should you ever encounter this error
when starting the game please try to maximize the console you 
use for playing. This is because currently there is no automatic 
font size adaption so depending on your console settings a 
minimum width and height is required. Alternatively or if 
maximizing doesn't help you can also lower the font size of the 
console.

- newer Python versions

Usually also Python 3.9 and onward should perfectly work for 
playing Qrogue but testing is currently done for Python 3.8 so 
there is no official support yet for other versions. The same 
is true if you decide to manually install the dependencies; newer 
version will likely work but are not recommended.

## How to play - Controls ##
- Navigate in menus: Arrow Keys, wasd
- Move in game world: Arrow Keys, wasd
- Scroll in popup: Arrow Keys, wasd
- Close popup: Space, Enter
- Reopen last popup: H
- Confirm selection (also in question popup): Space, Enter
- Cancel/back (also in question popup): Shift+A, Shift+Left, Backspace
- Pause: P, Tab
- Situational 
  - shortcut keys: 0-9
  - 
- Debug Keys (not for use in normal play through!)
  - Print screen: CTRL+P
  - Force re-render: CTRL+R 
  
## Feedback ##
We'd be very happy if you share any feedback with us, regardless whether you liked the game or not.
Just send it via Email to michael.artner@jku.at with the subject "Qrogue Feedback". 
It would also be nice if you could add your user-data folder ("qrogue/QrogueData", for normal installations it can be found in your virtual environment's packages) with the log files. Thanks!

If you find a typo: In the title of the popup window you should find something like "{@abc}" where abc is the message id. 
Please do tell us the message id so we have an easier time fixing it. Thanks!

## Outlook ##

What you can expect from Qrogue v0.5:
- better Popups
- automated testing
- Documentation

